CREATE OR REPLACE FUNCTION get_full_index_table(i_kat integer,i_index integer, i_path text, i_idlehr integer, lslink text, i_lang text)
  RETURNS SETOF index_table_type AS
$BODY$
declare
	rec record;
	rec2 record;
	r index_table_type;
	f_no_dp_first boolean;
	target text;
begin
	for rec in 
	with recursive st as (select b.name,a.*,non_empty(a.url_de,a.url_en,i_lang) as url2,
	non_empty(a.de,a.en,i_lang) as text,
	non_empty(a.auto_query_de,a.auto_query_en,i_lang) as auto_query,
	1 as level, get_order_number((100000-case when a.ordnung is null then 0 else a.ordnung end)::text)||non_empty(a.de,a.en,i_lang) as path 
	from index_files a left outer join file b on 	
	b.id=a.id_file  
	where a.id_super=i_kat and id_lehr=i_idlehr
	union all
	select curb.name, cur.*,non_empty(cur.url_de,cur.url_en,i_lang) as url2,
	non_empty(cur.de,cur.en,i_lang) as text,
	non_empty(cur.auto_query_de,cur.auto_query_en,i_lang) as auto_query,
prev.level+1 as level,prev.path||'/'||
get_order_number((100000-case when cur.ordnung is null then 0 else cur.ordnung end)::text)||
non_empty(cur.de,cur.en,i_lang) as path 	      
	from index_files cur left outer join file curb on curb.id=cur.id_file,st prev where 	
	cur.id_super=prev.id)
	select * from st order by path loop

 	  r.level:=rec.level;
          r.in_pfad:=false;
          r.aktiv:=false;
          r.id:=rec.id;
          r.id_parent=rec.id_super;
          r.name:=rec.text;
	  if rec.target_blank then r.target:='_blank';
	  else r.target:='';
	  end if;
	
	  if rec.id=i_index then
            r.aktiv:=true;
          elsif i_path like '%|'||rec.id||'|%' then
            r.in_pfad:=true;
	  end if;
	
	  if rec.name>'' then
	    if rec.auto_query='' then	  
              r.url:='/'||lslink||'/'||i_lang||'/'||rec.name||rec.qs;
              return next r;
	    elsif rec.auto_query>'' then
	      r.aktiv:=false;
	      for rec2 in execute rec.auto_query loop
                r.name:=rec2.text;
                r.url:='/'||lslink||'/'||i_lang||'/'||rec.name||rec.qs||rec2.wert;
		return next r;
	      end loop;
	    end if;
	  elsif rec.url2>'' then
	    r.url:=rec.url2;
            return next r;
	  else
            r.url:=null;
	    return next r;
	  end if;
 	end loop;
	return;
end;$BODY$
  LANGUAGE plpgsql;

select * from get_full_index_table(2000,10856,'1',5001,'xxx','de');


with recursive st as (select *,1 as level,de as path,id_super from index_files 
where id_super=2000 and id_lehr=5001
union all
select cur.*,prev.level+1 as level,prev.path||'/'||cur.de as path, cur.id_super from index_files cur,st prev where cur.id_super=prev.id)
select * from st;
