create or replace function get_ubt5_index(i_index int, i_idlehr int,lslink text,i_lang text) returns text as $$

declare
   rec record;
   out text;
   akt_level int;
   link_name text;
   target text;
   css_class text;
begin
   out:='';
   akt_level:=0;
   for rec in select * from get_index_table(i_index,i_idlehr,lslink,i_lang) loop

     if akt_level<rec.level then 
        out:=out||'<ul>';
        akt_level:=akt_level+1;
     elsif akt_level=rec.level then 
        out:=out||'</li>'||E'\n';
     end if;

     while akt_level>rec.level loop
        out:=out||'</li>'||E'\n'||'</ul>';
        akt_level:=akt_level-1;
     end loop;  

     link_name:=rec.name;
     if rec.url>'' then
     if rec.aktiv then css_class:=' class="active"'; else css_class:=''; end if;
     if rec.in_pfad then css_class:=' class="active"'; end if;
     if rec.target>'' then target:=' target="'||rec.target||'"'; 
     else target:='';
     end if;
     out:=out||'<li><a href="'||rec.url||'"'||target||css_class||'>'||link_name||'</a>';
     else out:=out||'<li>'||link_name;
     end if; 
   end loop;

   while akt_level>1 loop
      out:=out||'</li>'||E'\n'||'</ul>';
      akt_level:=akt_level-1;
   end loop;  
   
   if out>'' then
     out:=out||'</li></ul>'; 
   end if;

   return out;
end;
$$ language 'plpgsql';


